"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WidenImplementation = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright (c) 2017-present, Facebook, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _errors = require("../errors.js");

var _completions = require("../completions.js");

var _environment = require("../environment.js");

var _index = require("../methods/index.js");

var _generator = require("../utils/generator.js");

var _index2 = require("../values/index.js");

var _invariant = require("../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var WidenImplementation = exports.WidenImplementation = function () {
  function WidenImplementation() {
    _classCallCheck(this, WidenImplementation);
  }

  _createClass(WidenImplementation, [{
    key: "_widenArrays",
    value: function _widenArrays(realm, v1, v2) {
      var e = v1 && v1[0] || v2 && v2[0];
      if (e instanceof _index2.Value) return this._widenArraysOfValues(realm, v1, v2);else return this._widenArrayOfsMapEntries(realm, v1, v2);
    }
  }, {
    key: "_widenArrayOfsMapEntries",
    value: function _widenArrayOfsMapEntries(realm, a1, a2) {
      var empty = realm.intrinsics.empty;
      var n = Math.max(a1 && a1.length || 0, a2 && a2.length || 0);
      var result = [];
      for (var i = 0; i < n; i++) {
        var _ref = a1 && a1[i] || { $Key: empty, $Value: empty },
            key1 = _ref.$Key,
            val1 = _ref.$Value;

        var _ref2 = a2 && a2[i] || { $Key: empty, $Value: empty },
            key2 = _ref2.$Key,
            val2 = _ref2.$Value;

        if (key1 === undefined && key2 === undefined) {
          result[i] = { $Key: undefined, $Value: undefined };
        } else {
          var key3 = this.widenValues(realm, key1, key2);
          (0, _invariant2.default)(key3 instanceof _index2.Value);
          var val3 = this.widenValues(realm, val1, val2);
          (0, _invariant2.default)(val3 === undefined || val3 instanceof _index2.Value);
          result[i] = { $Key: key3, $Value: val3 };
        }
      }
      return result;
    }
  }, {
    key: "_widenArraysOfValues",
    value: function _widenArraysOfValues(realm, a1, a2) {
      var n = Math.max(a1 && a1.length || 0, a2 && a2.length || 0);
      var result = [];
      for (var i = 0; i < n; i++) {
        var wv = this.widenValues(realm, a1 && a1[i] || undefined, a2 && a2[i] || undefined);
        (0, _invariant2.default)(wv === undefined || wv instanceof _index2.Value);
        result[i] = wv;
      }
      return result;
    }

    // Returns a new effects summary that includes both e1 and e2.

  }, {
    key: "widenEffects",
    value: function widenEffects(realm, e1, e2) {
      var _e = _slicedToArray(e1, 5),
          result1 = _e[0],
          bindings1 = _e[2],
          properties1 = _e[3],
          createdObj1 = _e[4];

      var _e2 = _slicedToArray(e2, 5),
          result2 = _e2[0],
          bindings2 = _e2[2],
          properties2 = _e2[3],
          createdObj2 = _e2[4];

      var result = this.widenResults(realm, result1, result2);
      var bindings = this.widenBindings(realm, bindings1, bindings2);
      var properties = this.widenPropertyBindings(realm, properties1, properties2, createdObj1, createdObj2);
      var createdObjects = new Set(); // Top, since the empty set knows nothing. There is no other choice for widen.
      var generator = new _generator.Generator(realm); // code subject to widening will be generated somewhere else
      return [result, generator, bindings, properties, createdObjects];
    }
  }, {
    key: "widenResults",
    value: function widenResults(realm, result1, result2) {
      (0, _invariant2.default)(!(result1 instanceof _environment.Reference || result2 instanceof _environment.Reference), "loop bodies should not result in refs");
      (0, _invariant2.default)(!(result1 instanceof _completions.AbruptCompletion || result2 instanceof _completions.AbruptCompletion), "if a loop iteration ends abruptly, there is no need for fixed point computation");
      if (result1 instanceof _index2.Value && result2 instanceof _index2.Value) {
        var val = this.widenValues(realm, result1, result2);
        (0, _invariant2.default)(val instanceof _index2.Value);
        return val;
      }
      if (result1 instanceof _completions.PossiblyNormalCompletion && result2 instanceof _completions.PossiblyNormalCompletion) {
        //todo: #1174 figure out how to deal with loops that have embedded conditional exits
        // widen join pathConditions
        // widen normal result and Effects
        // use abrupt part of result2, depend stability to make this safe. See below.
        throw new _errors.FatalError();
      }
      // todo: #1174 figure out what a stable result is and how to check it
      (0, _invariant2.default)(false, "widening should happen only after result type has stablized");
    }
  }, {
    key: "widenMaps",
    value: function widenMaps(m1, m2, widen) {
      var m3 = new Map();
      m1.forEach(function (val1, key, map1) {
        var val2 = m2.get(key);
        var val3 = widen(key, val1, val2);
        m3.set(key, val3);
      });
      m2.forEach(function (val2, key, map2) {
        if (!m1.has(key)) {
          m3.set(key, widen(key, undefined, val2));
        }
      });
      return m3;
    }
  }, {
    key: "widenBindings",
    value: function widenBindings(realm, m1, m2) {
      var _this = this;

      var widen = function widen(b, v1, v2) {
        var result = _this.widenValues(realm, v1 || b.value, v2 || b.value);
        (0, _invariant2.default)(result instanceof _index2.Value);
        return result;
      };
      return this.widenMaps(m1, m2, widen);
    }

    // Returns an abstract value that includes both v1 and v2 as potential values.

  }, {
    key: "widenValues",
    value: function widenValues(realm, v1, v2) {
      if (Array.isArray(v1) || Array.isArray(v2)) {
        (0, _invariant2.default)(v1 === undefined || Array.isArray(v1));
        (0, _invariant2.default)(v2 === undefined || Array.isArray(v2));
        return this._widenArrays(realm, v1, v2);
      }
      (0, _invariant2.default)(v1 === undefined || v1 instanceof _index2.Value);
      (0, _invariant2.default)(v2 === undefined || v2 instanceof _index2.Value);
      if (v1 !== undefined && v2 !== undefined && !(v1 instanceof _index2.AbstractValue) && !(v2 instanceof _index2.AbstractValue) && (0, _index.StrictEqualityComparison)(realm, v1.throwIfNotConcrete(), v2.throwIfNotConcrete())) {
        return v1; // no need to widen a loop invariant value
      } else {
        return _index2.AbstractValue.createFromWidening(realm, v1 || realm.intrinsics.undefined, v2 || realm.intrinsics.undefined);
      }
    }
  }, {
    key: "widenPropertyBindings",
    value: function widenPropertyBindings(realm, m1, m2, c1, c2) {
      var _this2 = this;

      var widen = function widen(b, d1, d2) {
        (0, _invariant2.default)(d1 !== undefined || d2 !== undefined, "widenMaps ensures that this cannot happen");
        // If the PropertyBinding object has been freshly allocated do not widen (that happens in AbstractObjectValue)
        if (d1 === undefined) {
          if (b.object instanceof _index2.ObjectValue && c2.has(b.object)) return d2; // no widen
          if (b.descriptor !== undefined && m1.has(b)) {
            // property was present in (n-1)th iteration and deleted in nth iteration
            d1 = (0, _index.cloneDescriptor)(b.descriptor);
            (0, _invariant2.default)(d1 !== undefined);
            d1.value = realm.intrinsics.empty;
          } else {
            // no write to property in nth iteration, use the value from the (n-1)th iteration
            d1 = b.descriptor;
          }
        }
        if (d2 === undefined) {
          if (b.object instanceof _index2.ObjectValue && c1.has(b.object)) return d1; // no widen
          if (m2.has(b)) {
            // property was present in nth iteration and deleted in (n+1)th iteration
            d2 = (0, _index.cloneDescriptor)(d1);
            (0, _invariant2.default)(d2 !== undefined);
            d2.value = realm.intrinsics.empty;
          } else {
            // no write to property in (n+1)th iteration, use the value from the nth iteration
            d2 = d1;
          }
          (0, _invariant2.default)(d2 !== undefined);
        }
        return _this2.widenDescriptors(realm, d1, d2);
      };
      return this.widenMaps(m1, m2, widen);
    }
  }, {
    key: "widenDescriptors",
    value: function widenDescriptors(realm, d1, d2) {
      if (d1 === undefined) {
        // d2 is a property written to only in the (n+1)th iteration
        return d2; // no widening needed. Note that another fixed point iteration will occur.
      } else {
        if ((0, _index.equalDescriptors)(d1, d2)) {
          if (!(0, _index.IsDataDescriptor)(realm, d1)) return d1; // identical accessor properties need not be widened.
          var dc = (0, _index.cloneDescriptor)(d1);
          (0, _invariant2.default)(dc !== undefined);
          dc.value = this.widenValues(realm, d1.value, d2.value);
          return dc;
        }
        //todo: #1174 if we get here, the loop body contains a call to create a property and different iterations
        // create them differently. That seems beyond what a fixpoint computation can reasonably handle without
        // losing precision. Report an error here.
        throw new _errors.FatalError();
      }
    }

    // If e2 is the result of a loop iteration starting with effects e1 and it has the same elements as e1,
    // then we have reached a fixed point and no further calls to widen are needed. e1/e2 represent a general
    // summary of the loop, regardless of how many iterations will be performed at runtime.

  }, {
    key: "equalsEffects",
    value: function equalsEffects(e1, e2) {
      var _e3 = _slicedToArray(e1, 4),
          result1 = _e3[0],
          bindings1 = _e3[2],
          properties1 = _e3[3];

      var _e4 = _slicedToArray(e2, 4),
          result2 = _e4[0],
          bindings2 = _e4[2],
          properties2 = _e4[3];

      if (!this.equalsResults(result1, result2)) return false;
      if (!this.equalsBindings(bindings1, bindings2)) return false;
      if (!this.equalsPropertyBindings(properties1, properties2)) return false;
      return true;
    }
  }, {
    key: "equalsResults",
    value: function equalsResults(result1, result2) {
      if (result1 instanceof _index2.Value && result2 instanceof _index2.Value) return result1.equals(result2);
      return false;
    }
  }, {
    key: "equalsMap",
    value: function equalsMap(m1, m2, f) {
      m1.forEach(function (val1, key, map1) {
        var val2 = m2.get(key);
        if (val2 === undefined || !f(val2, val1)) return false;
      });
      m2.forEach(function (val2, key, map2) {
        if (!m1.has(key)) return false;
      });
      return true;
    }
  }, {
    key: "equalsBindings",
    value: function equalsBindings(m1, m2) {
      var equalsBinding = function equalsBinding(v1, v2) {
        if (v1 === undefined || v2 === undefined || !v1.equals(v2)) return false;
        return true;
      };
      return this.equalsMap(m1, m2, equalsBinding);
    }
  }, {
    key: "equalsPropertyBindings",
    value: function equalsPropertyBindings(m1, m2) {
      var _this3 = this;

      var equalsPropertyBinding = function equalsPropertyBinding(d1, d2) {
        if (d1 === undefined || d2 === undefined) return false;
        var _ref3 = [d1.value, d2.value],
            v1 = _ref3[0],
            v2 = _ref3[1];

        if (v1 === undefined) return v2 === undefined;
        if (v1 instanceof _index2.Value && v2 instanceof _index2.Value && !v1.equals(v2)) return false;
        if (Array.isArray(v1) && Array.isArray(v2)) {
          return _this3._equalsArray(v1, v2);
        }
        return false;
      };
      return this.equalsMap(m1, m2, equalsPropertyBinding);
    }
  }, {
    key: "_equalsArray",
    value: function _equalsArray(v1, v2) {
      var e = v1 && v1[0] || v2 && v2[0];
      if (e instanceof _index2.Value) return this._equalsArraysOfValue(v1, v2);else return this._equalsArrayOfsMapEntries(v1, v2);
    }
  }, {
    key: "_equalsArraysOfValue",
    value: function _equalsArraysOfValue(realm, a1, a2) {
      var empty = realm.intrinsics.empty;
      var n = Math.max(a1 && a1.length || 0, a2 && a2.length || 0);
      for (var i = 0; i < n; i++) {
        var _ref4 = a1 && a1[i] || { $Key: empty, $Value: empty },
            key1 = _ref4.$Key,
            val1 = _ref4.$Value;

        var _ref5 = a2 && a2[i] || { $Key: empty, $Value: empty },
            key2 = _ref5.$Key,
            val2 = _ref5.$Value;

        if (key1 === undefined) {
          if (key2 !== undefined) return false;
        } else {
          if (key1 instanceof _index2.Value && key2 instanceof _index2.Value && key1.equals(key2)) {
            if (val1 instanceof _index2.Value && val2 instanceof _index2.Value && val1.equals(val2)) continue;
          }
          return false;
        }
      }
      return true;
    }
  }, {
    key: "_equalsArrayOfsMapEntries",
    value: function _equalsArrayOfsMapEntries(realm, a1, a2) {
      var n = Math.max(a1 && a1.length || 0, a2 && a2.length || 0);
      for (var i = 0; i < n; i++) {
        var val1 = a1 && a1[i],
            val2 = a2 && a2[i];

        if (val1 instanceof _index2.Value && val2 instanceof _index2.Value && !val1.equals(val2)) return false;
      }
      return false;
    }
  }]);

  return WidenImplementation;
}();
//# sourceMappingURL=widen.js.map